
_main:
	LDI        R27, 255
	OUT        SPL+0, R27
	LDI        R27, 0
	OUT        SPL+1, R27

;ds1307.mpas,18 :: 		begin
;ds1307.mpas,19 :: 		twi_init(100000);
	PUSH       R2
	PUSH       R3
	PUSH       R4
	IN         R27, TWPS0_bit+0
	CBR        R27, BitMask(TWPS0_bit+0)
	OUT        TWPS0_bit+0, R27
	IN         R27, TWPS1_bit+0
	CBR        R27, BitMask(TWPS1_bit+0)
	OUT        TWPS1_bit+0, R27
	LDI        R27, 32
	OUT        TWBR+0, R27
	CALL       _TWI_Init+0
;ds1307.mpas,20 :: 		mint:=0;
	LDI        R27, 0
	STS        _mint+0, R27
;ds1307.mpas,21 :: 		hour:=0;
	LDI        R27, 0
	STS        _hour+0, R27
;ds1307.mpas,22 :: 		sec:=1;
	LDI        R27, 1
	STS        _sec+0, R27
;ds1307.mpas,23 :: 		DDRB:=0xff;
	LDI        R27, 255
	OUT        DDRB+0, R27
;ds1307.mpas,24 :: 		DDRD:=0x0f;
	LDI        R27, 15
	OUT        DDRD+0, R27
;ds1307.mpas,26 :: 		twi_start();
	CALL       _TWI_Start+0
;ds1307.mpas,27 :: 		twi_write(0xd0);
	LDI        R27, 208
	MOV        R2, R27
	CALL       _TWI_Write+0
;ds1307.mpas,28 :: 		twi_write(0);
	CLR        R2
	CALL       _TWI_Write+0
;ds1307.mpas,29 :: 		twi_stop();
	CALL       _TWI_Stop+0
;ds1307.mpas,31 :: 		twi_start();
	CALL       _TWI_Start+0
;ds1307.mpas,32 :: 		twi_write(0xd0);
	LDI        R27, 208
	MOV        R2, R27
	CALL       _TWI_Write+0
;ds1307.mpas,33 :: 		twi_write(1);
	LDI        R27, 1
	MOV        R2, R27
	CALL       _TWI_Write+0
;ds1307.mpas,34 :: 		twi_stop();
	CALL       _TWI_Stop+0
;ds1307.mpas,36 :: 		twi_start();
	CALL       _TWI_Start+0
;ds1307.mpas,37 :: 		twi_write(0xd0);
	LDI        R27, 208
	MOV        R2, R27
	CALL       _TWI_Write+0
;ds1307.mpas,38 :: 		twi_write(2);
	LDI        R27, 2
	MOV        R2, R27
	CALL       _TWI_Write+0
;ds1307.mpas,39 :: 		twi_stop();
	CALL       _TWI_Stop+0
;ds1307.mpas,41 :: 		while true do
L__main2:
;ds1307.mpas,43 :: 		if PIND.6=0 then begin
	IN         R27, PIND+0
	SBRC       R27, 6
	JMP        L__main7
;ds1307.mpas,44 :: 		mint:=dec2bcd(mint);
	LDS        R2, _mint+0
	CALL       _Dec2Bcd+0
	STS        _mint+0, R16
;ds1307.mpas,45 :: 		inc(mint);
	MOV        R17, R16
	SUBI       R17, 255
	STS        _mint+0, R17
;ds1307.mpas,46 :: 		if mint>89 then mint:=0;
	LDI        R16, 89
	CP         R16, R17
	BRLO       L__main108
	JMP        L__main10
L__main108:
	LDI        R27, 0
	STS        _mint+0, R27
L__main10:
;ds1307.mpas,47 :: 		twi_start();
	CALL       _TWI_Start+0
;ds1307.mpas,48 :: 		twi_write(0xd0);
	LDI        R27, 208
	MOV        R2, R27
	CALL       _TWI_Write+0
;ds1307.mpas,49 :: 		twi_write(1);
	LDI        R27, 1
	MOV        R2, R27
	CALL       _TWI_Write+0
;ds1307.mpas,50 :: 		twi_write(mint);
	LDS        R2, _mint+0
	CALL       _TWI_Write+0
;ds1307.mpas,51 :: 		twi_stop();
	CALL       _TWI_Stop+0
;ds1307.mpas,52 :: 		end;
L__main7:
;ds1307.mpas,53 :: 		if PIND.7=0 then begin
	IN         R27, PIND+0
	SBRC       R27, 7
	JMP        L__main13
;ds1307.mpas,54 :: 		hour:=dec2bcd(hour);
	LDS        R2, _hour+0
	CALL       _Dec2Bcd+0
	STS        _hour+0, R16
;ds1307.mpas,55 :: 		inc(hour);
	MOV        R17, R16
	SUBI       R17, 255
	STS        _hour+0, R17
;ds1307.mpas,56 :: 		if hour>35 then hour:=0;
	LDI        R16, 35
	CP         R16, R17
	BRLO       L__main109
	JMP        L__main16
L__main109:
	LDI        R27, 0
	STS        _hour+0, R27
L__main16:
;ds1307.mpas,57 :: 		twi_start();
	CALL       _TWI_Start+0
;ds1307.mpas,58 :: 		twi_write(0xd0);
	LDI        R27, 208
	MOV        R2, R27
	CALL       _TWI_Write+0
;ds1307.mpas,59 :: 		twi_write(2);
	LDI        R27, 2
	MOV        R2, R27
	CALL       _TWI_Write+0
;ds1307.mpas,60 :: 		twi_write(hour);
	LDS        R2, _hour+0
	CALL       _TWI_Write+0
;ds1307.mpas,61 :: 		twi_stop();
	CALL       _TWI_Stop+0
;ds1307.mpas,62 :: 		end;
L__main13:
;ds1307.mpas,63 :: 		twi_start();
	CALL       _TWI_Start+0
;ds1307.mpas,64 :: 		twi_write(0xd0);
	LDI        R27, 208
	MOV        R2, R27
	CALL       _TWI_Write+0
;ds1307.mpas,65 :: 		twi_write(0);
	CLR        R2
	CALL       _TWI_Write+0
;ds1307.mpas,66 :: 		twi_start();
	CALL       _TWI_Start+0
;ds1307.mpas,67 :: 		twi_write(0xd1);
	LDI        R27, 209
	MOV        R2, R27
	CALL       _TWI_Write+0
;ds1307.mpas,68 :: 		sec:=twi_read(1);
	LDI        R27, 1
	MOV        R2, R27
	CALL       _TWI_Read+0
	STS        _sec+0, R16
;ds1307.mpas,69 :: 		mint:=twi_read(1);
	LDI        R27, 1
	MOV        R2, R27
	CALL       _TWI_Read+0
	STS        _mint+0, R16
;ds1307.mpas,70 :: 		hour:=twi_read(0);
	CLR        R2
	CALL       _TWI_Read+0
	STS        _hour+0, R16
;ds1307.mpas,71 :: 		twi_stop();
	CALL       _TWI_Stop+0
;ds1307.mpas,73 :: 		sec:=bcd2dec(sec);
	LDS        R2, _sec+0
	CALL       _Bcd2Dec+0
	STS        _sec+0, R16
;ds1307.mpas,74 :: 		mint:=bcd2dec(mint);
	LDS        R2, _mint+0
	CALL       _Bcd2Dec+0
	STS        _mint+0, R16
;ds1307.mpas,75 :: 		hour:=bcd2dec(hour);
	LDS        R2, _hour+0
	CALL       _Bcd2Dec+0
	STS        _hour+0, R16
;ds1307.mpas,77 :: 		bytetostr(mint,mins);
	LDI        R27, #lo_addr(_mins+0)
	MOV        R3, R27
	LDI        R27, hi_addr(_mins+0)
	MOV        R4, R27
	LDS        R2, _mint+0
	CALL       _ByteToStr+0
;ds1307.mpas,78 :: 		bytetostr(hour,hours);
	LDI        R27, #lo_addr(_hours+0)
	MOV        R3, R27
	LDI        R27, hi_addr(_hours+0)
	MOV        R4, R27
	LDS        R2, _hour+0
	CALL       _ByteToStr+0
;ds1307.mpas,80 :: 		for temp:=1 to 25 do begin
	LDI        R27, 1
	STS        _temp+0, R27
	LDI        R27, 0
	STS        _temp+1, R27
L__main19:
;ds1307.mpas,81 :: 		for i:=0 to 3 do begin
	LDI        R27, 0
	STS        _i+0, R27
	STS        _i+1, R27
L__main24:
;ds1307.mpas,82 :: 		if i>=2 then begin
	LDS        R18, _i+0
	LDS        R19, _i+1
	LDI        R16, 2
	LDI        R17, 0
	CP         R18, R16
	CPC        R19, R17
	BRGE       L__main110
	JMP        L__main29
L__main110:
;ds1307.mpas,83 :: 		if i=2 then portd:=4;
	LDS        R16, _i+0
	LDS        R17, _i+1
	CPI        R17, 0
	BRNE       L__main111
	CPI        R16, 2
L__main111:
	BREQ       L__main112
	JMP        L__main32
L__main112:
	LDI        R27, 4
	OUT        PORTD+0, R27
L__main32:
;ds1307.mpas,84 :: 		if i=3 then portd:=8;
	LDS        R16, _i+0
	LDS        R17, _i+1
	CPI        R17, 0
	BRNE       L__main113
	CPI        R16, 3
L__main113:
	BREQ       L__main114
	JMP        L__main35
L__main114:
	LDI        R27, 8
	OUT        PORTD+0, R27
L__main35:
;ds1307.mpas,85 :: 		case mins[i-1] of
	LDS        R18, _i+0
	SUBI       R18, 1
	LDI        R16, #lo_addr(_mins+0)
	LDI        R17, hi_addr(_mins+0)
	MOV        R30, R18
	LDI        R31, 0
	ADD        R30, R16
	ADC        R31, R17
	LD         R16, Z
;ds1307.mpas,86 :: 		'1':portb:=d1;
	CPI        R16, 49
	BREQ       L__main115
	JMP        L__main40
L__main115:
	LDI        R27, 249
	OUT        PORTB+0, R27
	JMP        L__main37
L__main40:
;ds1307.mpas,87 :: 		'2':portb:=d2;
	CPI        R16, 50
	BREQ       L__main116
	JMP        L__main43
L__main116:
	LDI        R27, 164
	OUT        PORTB+0, R27
	JMP        L__main37
L__main43:
;ds1307.mpas,88 :: 		'3':portb:=d3;
	CPI        R16, 51
	BREQ       L__main117
	JMP        L__main46
L__main117:
	LDI        R27, 176
	OUT        PORTB+0, R27
	JMP        L__main37
L__main46:
;ds1307.mpas,89 :: 		'4':portb:=d4;
	CPI        R16, 52
	BREQ       L__main118
	JMP        L__main49
L__main118:
	LDI        R27, 153
	OUT        PORTB+0, R27
	JMP        L__main37
L__main49:
;ds1307.mpas,90 :: 		'5':portb:=d5;
	CPI        R16, 53
	BREQ       L__main119
	JMP        L__main52
L__main119:
	LDI        R27, 146
	OUT        PORTB+0, R27
	JMP        L__main37
L__main52:
;ds1307.mpas,91 :: 		'6':portb:=d6;
	CPI        R16, 54
	BREQ       L__main120
	JMP        L__main55
L__main120:
	LDI        R27, 130
	OUT        PORTB+0, R27
	JMP        L__main37
L__main55:
;ds1307.mpas,92 :: 		'7':portb:=d7;
	CPI        R16, 55
	BREQ       L__main121
	JMP        L__main58
L__main121:
	LDI        R27, 248
	OUT        PORTB+0, R27
	JMP        L__main37
L__main58:
;ds1307.mpas,93 :: 		'8':portb:=d8;
	CPI        R16, 56
	BREQ       L__main122
	JMP        L__main61
L__main122:
	LDI        R27, 128
	OUT        PORTB+0, R27
	JMP        L__main37
L__main61:
;ds1307.mpas,94 :: 		'9':portb:=d9;
	CPI        R16, 57
	BREQ       L__main123
	JMP        L__main64
L__main123:
	LDI        R27, 144
	OUT        PORTB+0, R27
	JMP        L__main37
L__main64:
;ds1307.mpas,95 :: 		'0':portb:=d0;
	CPI        R16, 48
	BREQ       L__main124
	JMP        L__main67
L__main124:
	LDI        R27, 192
	OUT        PORTB+0, R27
	JMP        L__main37
L__main67:
;ds1307.mpas,96 :: 		' ':portb:=d0;
	CPI        R16, 32
	BREQ       L__main125
	JMP        L__main70
L__main125:
	LDI        R27, 192
	OUT        PORTB+0, R27
	JMP        L__main37
L__main70:
L__main37:
;ds1307.mpas,98 :: 		end
	JMP        L__main30
;ds1307.mpas,99 :: 		else begin
L__main29:
;ds1307.mpas,100 :: 		portd:=i+1;
	LDS        R16, _i+0
	MOV        R18, R16
	SUBI       R18, 255
	OUT        PORTD+0, R18
;ds1307.mpas,101 :: 		case hours[i+1] of
	LDI        R16, #lo_addr(_hours+0)
	LDI        R17, hi_addr(_hours+0)
	MOV        R30, R18
	LDI        R31, 0
	ADD        R30, R16
	ADC        R31, R17
	LD         R16, Z
;ds1307.mpas,102 :: 		'1':portb:=d1;
	CPI        R16, 49
	BREQ       L__main126
	JMP        L__main74
L__main126:
	LDI        R27, 249
	OUT        PORTB+0, R27
	JMP        L__main71
L__main74:
;ds1307.mpas,103 :: 		'2':portb:=d2;
	CPI        R16, 50
	BREQ       L__main127
	JMP        L__main77
L__main127:
	LDI        R27, 164
	OUT        PORTB+0, R27
	JMP        L__main71
L__main77:
;ds1307.mpas,104 :: 		'3':portb:=d3;
	CPI        R16, 51
	BREQ       L__main128
	JMP        L__main80
L__main128:
	LDI        R27, 176
	OUT        PORTB+0, R27
	JMP        L__main71
L__main80:
;ds1307.mpas,105 :: 		'4':portb:=d4;
	CPI        R16, 52
	BREQ       L__main129
	JMP        L__main83
L__main129:
	LDI        R27, 153
	OUT        PORTB+0, R27
	JMP        L__main71
L__main83:
;ds1307.mpas,106 :: 		'5':portb:=d5;
	CPI        R16, 53
	BREQ       L__main130
	JMP        L__main86
L__main130:
	LDI        R27, 146
	OUT        PORTB+0, R27
	JMP        L__main71
L__main86:
;ds1307.mpas,107 :: 		'6':portb:=d6;
	CPI        R16, 54
	BREQ       L__main131
	JMP        L__main89
L__main131:
	LDI        R27, 130
	OUT        PORTB+0, R27
	JMP        L__main71
L__main89:
;ds1307.mpas,108 :: 		'7':portb:=d7;
	CPI        R16, 55
	BREQ       L__main132
	JMP        L__main92
L__main132:
	LDI        R27, 248
	OUT        PORTB+0, R27
	JMP        L__main71
L__main92:
;ds1307.mpas,109 :: 		'8':portb:=d8;
	CPI        R16, 56
	BREQ       L__main133
	JMP        L__main95
L__main133:
	LDI        R27, 128
	OUT        PORTB+0, R27
	JMP        L__main71
L__main95:
;ds1307.mpas,110 :: 		'9':portb:=d9;
	CPI        R16, 57
	BREQ       L__main134
	JMP        L__main98
L__main134:
	LDI        R27, 144
	OUT        PORTB+0, R27
	JMP        L__main71
L__main98:
;ds1307.mpas,111 :: 		'0':portb:=d0;
	CPI        R16, 48
	BREQ       L__main135
	JMP        L__main101
L__main135:
	LDI        R27, 192
	OUT        PORTB+0, R27
	JMP        L__main71
L__main101:
;ds1307.mpas,112 :: 		' ':portb:=d0;
	CPI        R16, 32
	BREQ       L__main136
	JMP        L__main104
L__main136:
	LDI        R27, 192
	OUT        PORTB+0, R27
	JMP        L__main71
L__main104:
L__main71:
;ds1307.mpas,114 :: 		end;
L__main30:
;ds1307.mpas,115 :: 		delay_ms(10);
	LDI        R17, 104
	LDI        R16, 229
L__main105:
	DEC        R16
	BRNE       L__main105
	DEC        R17
	BRNE       L__main105
;ds1307.mpas,116 :: 		end;
	LDS        R16, _i+0
	LDS        R17, _i+1
	CPI        R17, 0
	BRNE       L__main137
	CPI        R16, 3
L__main137:
	BRNE       L__main138
	JMP        L__main27
L__main138:
	LDS        R16, _i+0
	LDS        R17, _i+1
	SUBI       R16, 255
	SBCI       R17, 255
	STS        _i+0, R16
	STS        _i+1, R17
	JMP        L__main24
L__main27:
;ds1307.mpas,117 :: 		end;
	LDS        R16, _temp+0
	LDS        R17, _temp+1
	CPI        R17, 0
	BRNE       L__main139
	CPI        R16, 25
L__main139:
	BRNE       L__main140
	JMP        L__main22
L__main140:
	LDS        R16, _temp+0
	LDS        R17, _temp+1
	SUBI       R16, 255
	SBCI       R17, 255
	STS        _temp+0, R16
	STS        _temp+1, R17
	JMP        L__main19
L__main22:
;ds1307.mpas,118 :: 		end;
	JMP        L__main2
;ds1307.mpas,120 :: 		end.
L_end_main:
	POP        R4
	POP        R3
	POP        R2
L__main_end_loop:
	JMP        L__main_end_loop
; end of _main
